/* Angela Bolton	CSCI 142	3-09-05	
   Basic texturing code adapted from a sample in the OpenGL Redbook.
   PPM loading and texture loading adapted from code found at 
   http://www.cs.rit.edu/usr/local/pub/ncs/graphics/OpenGL/ExamplesLab4/Texture/maiden.c
   The code I started with is located at http://www.ultimategameprogramming.com/.
   Hey, I did code a lot of this myself too!							           */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <windows.h>  
//#include <gl/gl.h>    
#include <glut.h>  

#define XYZ 12	/* Vertexes for the cube. */
#define ZYX 1	/* Texture coordinates for the cube. */

#define KEY_A 97	/* ASCII Key values. */
#define KEY_S 115
#define KEY_D 100
#define KEY_F 102
#define KEY_UP 101
#define KEY_DOWN 103
static GLuint texName;
GLubyte* texture;

/* Functions. */
int InitializeGL(void);
void RenderScene(void);
unsigned char* ppmRead(char* filename, int* width, int* height);
void textures (char filename[]);
GLvoid window_key(unsigned char key, int x, int y);
GLvoid window_special_key(int key, int x, int y);

/* Rotation inits. */
float xRotation = 0.0f;
float zRotation = 0.0f;
float yRotation = 0.0f;
float incz = 0.1f;
float incxy = 0.1f;

/* Translation unit. */
double transl = -10.0f;

/* Lights. */
float LightPosition[] = {1.75f, 1.75f, 2.0f, 0.9f};
float ambientLight[] = {0.1f, 0.1f, 0.1f, 1.0f}; 
float diffuseLight[] = {1.0f, 1.0f, 1.0f, 1.0f}; 


int main(int argc, char **argv)
{
	printf("a increases xy rotation, s decreases. d increases z rotation, f decreases.\n\n");
	printf("The up arrow zooms in, the down arrow zooms out. Enjoy!\n\n");
	glutInit(&argc, argv); 

	/* Double for animation, depth for depth, and multisample I'm not sure about. */
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH | GLUT_MULTISAMPLE);

	glutInitWindowSize(800, 800);

	glutCreateWindow("Maybe we -are- the center of the universe,,,");

	/* Tell glut which function will be called every frame. */
	glutDisplayFunc(RenderScene);

	/* Test the Init. */
	if(!InitializeGL())
		exit(0);

	glMatrixMode(GL_PROJECTION);

	/* Set the persepctive.  View angel 45, aspect ratio 1, near plane 1
	and the far clipping plane at 200.  The last two mean to start drawing
    from 1 unit in front of you up to 200 units far. */
	gluPerspective(45, 1.0, 1.0, 200.0);
	
	glMatrixMode(GL_MODELVIEW);

	glutKeyboardFunc(&window_key);
	glutSpecialFunc(&window_special_key);
	glutMainLoop();

    return 0;
}
/* END FUNCTION MAIN. */


/* Initialize OpenGL with lights, materials, minor texture init... */
int InitializeGL(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);

	/* Allow for smooth shading and depth testing. */
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

    glGenTextures(1, &texName);

    glMatrixMode(GL_MODELVIEW);

    glEnable(GL_LIGHTING);

	/* Fixing up those lights. */
    glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
    glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
    glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 60.0f); /* Gives the sphere some depth. */
    glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 75.0f);

    /* Turn on da light! */
    glEnable(GL_LIGHT0);

    /* Lights up the pretty Earth. */
    glEnable(GL_COLOR_MATERIAL);

    return 1;
}

/* Makes a happy little cube. */
void DrawCube()
{
	glEnable(GL_TEXTURE_2D); /* Let's texture this thing! */
	/* Let's rotate this thing too! */
	glRotatef(xRotation, 1.0f, 0.0f, 0.0f);
	glRotatef(yRotation, 0.0f, 1.0f, 0.0f);
	glRotatef(zRotation, 0.0f, 0.0f, 1.0f);
	glBegin(GL_QUADS);
		/* Front poly */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-XYZ, -XYZ, XYZ);
		glTexCoord2f(0.0, ZYX);   glVertex3f(-XYZ, XYZ, XYZ);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(XYZ, XYZ, XYZ);
		glTexCoord2f(ZYX, 0.0);   glVertex3f(XYZ, -XYZ, XYZ);

		/* Draw the back polygon. */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-XYZ, -XYZ, -XYZ);
		glTexCoord2f(0.0, ZYX);   glVertex3f(-XYZ, XYZ, -XYZ);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(XYZ, XYZ, -XYZ);
		glTexCoord2f(ZYX, 0.0);   glVertex3f(XYZ, -XYZ, -XYZ);

		/* Draw the bottom polygon. */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-XYZ, -XYZ, -XYZ);
		glTexCoord2f(0.0, ZYX);   glVertex3f(-XYZ, -XYZ, XYZ);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(XYZ, -XYZ, XYZ);
		glTexCoord2f(ZYX, 0.0);   glVertex3f(XYZ, -XYZ, -XYZ);
			
		/* Draw the top polygon. */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-XYZ, XYZ, -XYZ);
        glTexCoord2f(0.0, ZYX);   glVertex3f(-XYZ, XYZ, XYZ);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(XYZ, XYZ, XYZ);
		glTexCoord2f(ZYX, 0.0);   glVertex3f(XYZ, XYZ, -XYZ);

		/* Draw the left polygon. */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-XYZ, -XYZ, -XYZ);
		glTexCoord2f(0.0, ZYX);   glVertex3f(-XYZ, -XYZ, XYZ);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(-XYZ, XYZ, XYZ); 
		glTexCoord2f(ZYX, 0.0);   glVertex3f(-XYZ, XYZ, -XYZ);

		/* Draw the right polygon. */
		glTexCoord2f(0.0, 0.0);   glVertex3f(XYZ, -XYZ, -XYZ);      
        glTexCoord2f(0.0, ZYX);   glVertex3f(XYZ, -XYZ, XYZ);      
        glTexCoord2f(ZYX, ZYX);   glVertex3f(XYZ, XYZ, XYZ);		
        glTexCoord2f(ZYX, 0.0);   glVertex3f(XYZ, XYZ, -XYZ);
  
	glEnd();
	glFlush();
    glDisable(GL_TEXTURE_2D);
}

/* Puts everything on screen. */
void RenderScene() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	textures("earth32.ppm"); /* Let's texture Druidia first because it's rendered first. */
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glBindTexture(GL_TEXTURE_2D, texName);
	
	glLoadIdentity();
	
   /* Move BACK 12 units. */
    glTranslatef(0.0f, 0.0f, transl);

   /* Draw and set up texturing for Druidia.  This will be inside the cube. */
	glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );
    glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP );
    glEnable( GL_TEXTURE_GEN_S );
    glEnable( GL_TEXTURE_GEN_T );
    glEnable( GL_TEXTURE_2D );
	glutSolidSphere(1.9, 50, 50);
	glDisable( GL_TEXTURE_2D );
	glDisable( GL_TEXTURE_GEN_S );
    glDisable( GL_TEXTURE_GEN_T  );

	/* Here's the air shield. */
    glEnable (GL_BLEND);
    glBlendFunc(GL_SRC_COLOR,GL_ONE);
	glutSolidSphere(1.95, 50, 50);
/*	glPopMatrix(); coupled with push matrix makes the background spin exponentially faster. */

    glDisable(GL_LIGHTING);

	glPushMatrix();
	textures("urspace.ppm");
	glTranslatef(0.0f, 0.0f, -120.0f);
		glEnable(GL_TEXTURE_2D);
		glBegin(GL_QUADS);
		/* Front poly */
		glTexCoord2f(0.0, 0.0);   glVertex3f(-70, -70, 70);
		glTexCoord2f(0.0, ZYX);   glVertex3f(-70, 70, 70);
		glTexCoord2f(ZYX, ZYX);   glVertex3f(70, 70, 70);
		glTexCoord2f(ZYX, 0.0);   glVertex3f(70, -70, 70);
		glEnd();
		glDisable(GL_TEXTURE_2D);

	glPopMatrix();
	textures("stars512r.ppm");  /* Let's get the texturing going for the cube now. */
   	DrawCube();/* Draw cube with sphere(s) inside. */

/*	glPushMatrix(); It's a pretty darn cool effect, but might be potentially dangerous. */


	glDisable(GL_BLEND);

    glEnable(GL_LIGHTING);

   /* Add 0.1 to each rotation directions... */
	xRotation = yRotation += incxy;
	
   /* ... and 0.5 to the z axis. */
	zRotation += incz;

	glutSwapBuffers(); 
    glutPostRedisplay();    
}


/* Loads and returns a pointer to a PPM image. */
unsigned char* ppmRead(char* filename, int* width, int* height ) {

	FILE* fp;
    int i, w, h, d;
    unsigned char* image;
    char head[70];		// max line <= 70 in PPM (per spec).

    fp = fopen( filename, "rb" );
    if ( !fp ) {
		perror(filename);
		return NULL;
    }
 
    fgets(head, 70, fp);
    if (strncmp(head, "P6", 2)) {
		fprintf(stderr, "%s: Not a raw PPM file\n", filename);
        return NULL;
    }

    i = 0;
    while( i < 3 ) {
		fgets( head, 70, fp );
		if ( head[0] == '#' )		// skip comments.
			continue;
		if ( i == 0 )
			i += sscanf( head, "%d %d %d", &w, &h, &d );
		else if ( i == 1 )
			i += sscanf( head, "%d %d", &h, &d );
		else if ( i == 2 )
			i += sscanf( head, "%d", &d );
	}

   
	image = (unsigned char*) malloc( sizeof( unsigned char ) * w * h * 3 );
    fread( image, sizeof( unsigned char ), w * h * 3, fp );
    fclose( fp );

    *width = w;
    *height = h;
    return image;

}

/* Loads the textures passed to it to whatever primitive/poly comes up next. */
void textures( char filename[] ) {

	GLint w, h, i;

    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );

    // XXX - RE bug - must enable texture before bind.
    glEnable( GL_TEXTURE_2D );

    for ( i = 0; i < 4; i++ ) {
		glBindTexture( GL_TEXTURE_2D, i + 1 );
		texture = (GLubyte*) ppmRead(filename, &w, &h );
		gluBuild2DMipmaps( GL_TEXTURE_2D, 3, w, h,
	                 GL_RGB, GL_UNSIGNED_BYTE, texture );
        free( texture );
    }

    // XXX - RE bug - must enable texture before bind. 
	glDisable( GL_TEXTURE_2D );

}


/* Does stuff if certain keys are pressed. :D */
GLvoid window_key(unsigned char key, int x, int y) 
{
	switch (key) {    
		case KEY_A:
			if (incxy < 10)
			incxy+= .1;
			break;
		case KEY_S:
			if (incxy > -10)
			incxy-= .1;
			break;
		case KEY_D:
			if (incz < 10)
			incz+= .1;
			break;
		case KEY_F:
			if (incz > -10)
			incz-= .1;
			break;
		default:
			printf ("Pressing %d doesn't do anything.\n", key);
			break;
	 }    
}

/* Does stuff if keys with non-ASCII values are pressed. */
GLvoid window_special_key(int key, int x, int y) 
{    
	switch (key) {    
		case KEY_UP: 
			transl += .1;
			break;
		case KEY_DOWN: 
			transl -= .1;
			break;
		default:
			printf ("Pressing %d doesn't do anything.\n", key);
			break;
	}
}
